import { Integration } from './integration';
import { Agent } from './agent';
import { Logger, RegisteredLogger } from './logger';
import { AllTools, ToolApi } from './tools/types';
export declare class Mastra<TIntegrations extends Integration[], MastraTools extends Record<string, ToolApi<Record<string, any>, Record<string, any>, TIntegrations>> = {}> {
    private tools;
    private agents;
    private integrations;
    private logger;
    private syncs;
    constructor(config: {
        tools: MastraTools;
        syncs: Record<string, (params: {
            tools: AllTools;
        }) => Promise<void>>;
        agents: Agent<TIntegrations, MastraTools>[];
        integrations: TIntegrations;
        logger?: Logger;
    });
    sync(key: string, params: Record<string, any>): Promise<void>;
    getAgent(name: string): Agent<TIntegrations, MastraTools, keyof (MastraTools extends {
        [x: string]: ToolApi<TIntegrations, Record<string, any>, Record<string, any>>;
    } ? MastraTools : {}) | keyof (TIntegrations extends Integration[] ? (import("./tools/types").IntegrationTools<TIntegrations[number]> extends infer T ? T extends import("./tools/types").IntegrationTools<TIntegrations[number]> ? T extends any ? (k: T) => void : never : never : never) extends (k: infer I) => void ? I : never : {})>;
    getIntegration(name: string): Integration;
    availableIntegrations(): {
        name: string;
        integration: Integration;
    }[];
    getTools(): AllTools<TIntegrations, MastraTools>;
    setLogger({ key, logger }: {
        key: RegisteredLogger;
        logger: Logger;
    }): void;
    getLogger(key: RegisteredLogger): Logger<import("./logger").BaseLogMessage> | undefined;
}
export * from './agent';
export * from './integration';
export * from './tools/types';
export * from './tools';
export * from './logger';
//# sourceMappingURL=index.d.ts.map